## ecflow 5.12.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_CXX_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
##############################################################################

# need 3.12.0 as this has findBoost fix for the latest boost version 1.67
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

# ===========================================================================
# Change the default if NO CMAKE_BUILD_TYPE specified
if (NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build Configuration type" FORCE)
endif()

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild ) # Before project()  

# this will generate variables, see ACore/ecflow_version.h.in
project( ecflow LANGUAGES CXX VERSION 5.12.0 )

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.6 )
include(CompilerOptions)

###############################################################################
# local project

ecbuild_declare_project()

ecbuild_info( "CMAKE_MODULE_PATH        : ${CMAKE_MODULE_PATH}")
ecbuild_info( "CMAKE_INSTALL_PREFIX     : ${CMAKE_INSTALL_PREFIX}" )
ecbuild_info( "ecflow_BINARY_DIR        : ${ecflow_BINARY_DIR}" )
ecbuild_info( "ecflow_SOURCE_DIR        : ${ecflow_SOURCE_DIR}" )


# =========================================================================================
# Options , be aware of caching, when modifying on the command line. 
# Ideally start fresh or remove cache CmakeCache.txt in build dir
# =========================================================================================
option( ENABLE_SERVER              "Build the server, can be switched off if just building UI" ON  )
option( ENABLE_PYTHON              "enable python interface"         ON  )
option( ENABLE_UI                  "Build ecFlowUI"                  ON  ) 
option( ENABLE_STATIC_BOOST_LIBS   "Link with boost libs statically" ON  )
option( ENABLE_ALL_TESTS           "This includes performance/migration/regression tests" OFF )
option( ENABLE_UI_BACKTRACE        "Print a UI debug backtrace"         OFF ) 
option( ENABLE_UI_USAGE_LOG        "Enable UI usage logging"            OFF )
option( ENABLE_SSL                 "Enable SSL encrypted communication" ON )
option( ENABLE_PYTHON_PTR_REGISTER "Some compilers/boost versions do not register shared ptr automatically" OFF  )
option( ENABLE_PYTHON_UNDEF_LOOKUP "Some boost/python versions are too closely linked" OFF  )
option( ENABLE_HTTP                "Enable HTTP server (experimental)" ON  )
option( ENABLE_HTTP_COMPRESSION    "Enable compression support by HTTP server" ON )
option( ENABLE_UDP                 "Enable UDP server (experimental)" ON )
option( ENABLE_DOCS                "Enable Documentation" OFF )

include(Policies NO_POLICY_SCOPE)

# =========================================================================================
# Dependency: Qt
# =========================================================================================
# Qt for ecFlowUI.
# Algorithm: we test for Qt6 - if it's there, then use it; otherwise look for Qt5.
#            if we don't find that, then we cannot build ecFlowUI.
# -----------------------------------------------------------------------------------------
if(ENABLE_UI)

  ecbuild_info("")
  ecbuild_info("------------------------------ Qt start ---------------------------")
  ecbuild_info("ecFlowUI is enabled - searching for Qt6/Qt5")
  ecbuild_info("To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH")

  find_package(Qt6Widgets)
  if( Qt6Widgets_FOUND )
    find_package(Qt6Core5Compat  REQUIRED)
    find_package(Qt6Gui          REQUIRED)
    find_package(Qt6Network      REQUIRED)
    find_package(Qt6Svg          REQUIRED)
    find_package(Qt6Charts)

    ecbuild_debug("Qt6 version ${Qt6Widgets_VERSION_STRING} was found")
    set(ECFLOW_QT_INCLUDE_DIR ${Qt6Core5Compat_INCLUDE_DIRS} ${Qt6Widgets_INCLUDE_DIRS} ${Qt6Gui_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS} ${Qt6Svg_INCLUDE_DIRS})
    set(ECFLOW_QT_LIBRARIES  ${Qt6Core5Compat_LIBRARIES} ${Qt6Widgets_LIBRARIES}    ${Qt6Gui_LIBRARIES}   ${Qt6Network_LIBRARIES} ${Qt6Svg_LIBRARIES})
    set(ECFLOW_QT6 1)
    add_definitions(-DECFLOW_QT6)

    if(Qt6Charts_FOUND)
      ecbuild_info("Qt6Charts was found - the server log viewer will be built")
      list(APPEND ECFLOW_QT_INCLUDE_DIR ${Qt6Charts_INCLUDE_DIRS})
      list(APPEND ECFLOW_QT_LIBRARIES  ${Qt6Charts_LIBRARIES})
      set(ECFLOW_LOGVIEW 1)
      add_definitions(-DECFLOW_LOGVIEW)
    else()
      ecbuild_info("Qt6Charts was not found - the server log viewer will not be built")
    endif()
  else()
    find_package(Qt5Widgets)
    if (Qt5Widgets_FOUND)
      find_package(Qt5Gui          REQUIRED)
      find_package(Qt5Network      REQUIRED)
      find_package(Qt5Svg          REQUIRED)
      find_package(Qt5Charts)

      ecbuild_info("Qt5 version ${Qt5Widgets_VERSION_STRING} was found")
      set(ECFLOW_QT_INCLUDE_DIR ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Svg_INCLUDE_DIRS})
      set(ECFLOW_QT_LIBRARIES   ${Qt5Widgets_LIBRARIES}    ${Qt5Gui_LIBRARIES}   ${Qt5Network_LIBRARIES} ${Qt5Svg_LIBRARIES})
      set(ECFLOW_QT5 1)
      add_definitions(-DECFLOW_QT5)

      if(Qt5Charts_FOUND)
        ecbuild_info("Qt5Charts was found - the server log viewer will be built")
        list(APPEND ECFLOW_QT_INCLUDE_DIR ${Qt5Charts_INCLUDE_DIRS})
        list(APPEND ECFLOW_QT_LIBRARIES  ${Qt5Charts_LIBRARIES})
        set(ECFLOW_LOGVIEW 1)
        add_definitions(-DECFLOW_LOGVIEW)
      else()
        ecbuild_info("Qt5Charts was not found - the server log viewer will not be built")
      endif()
    else()
      ecbuild_critical("Qt5 Widgets, Network and Gui not found - these are required for ecFlowUI; or use -DENABLE_UI=OFF")
    endif()
  endif()

  set(ECFLOW_QT 1)
  add_definitions(-DQT_NO_KEYWORDS) # We need to disable keywords because there is a problem in using Qt and boost together.
  ecbuild_info("------------------------------ Qt end----------------------------")
  ecbuild_info("")

endif()


# sanity check - cannot set ENABLE_UI_BACKTRACE if UI is OFF
if(ENABLE_UI_BACKTRACE AND (NOT ENABLE_UI))
  ecbuild_warn("Cannot ENABLE_UI_BACKTRACE if UI is not enabled")
  set(ENABLE_UI_BACKTRACE OFF)
endif()

# sanity check - cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI and ENABLE_UI_BACKTRACE are OFF
if(UI_BACKTRACE_EMAIL_ADDRESS_FILE AND (NOT ENABLE_UI))
  ecbuild_warn("Cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI is not enabled")
  set(UI_BACKTRACE_EMAIL_ADDRESS_FILE)
endif()

# sanity check - cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is OFF
if(UI_LOG_FILE AND (NOT ENABLE_UI_USAGE_LOG))
  ecbuild_warn("Cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is not enabled")
  set(UI_LOG_FILE)
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_FILE))
  ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT LOGUI_LOG_FILE))
  ecbuild_error("If ENABLE_UI_USAGE_LOG is set, LOGUI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_SITE_TAG
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_SITE_TAG))
  ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_SITE_TAG must also be set")
endif()

# sanity check - cannot set UI_SYSTEM_SERVERS_LIST if UI IS OFF
if(UI_SYSTEM_SERVERS_LIST AND (NOT ENABLE_UI))
  ecbuild_warn("Cannot set UI_SYSTEM_SERVERS_LIST if UI is not enabled")
  set(UI_SYSTEM_SERVERS_LIST)
endif()

if(ENABLE_HTTP AND NOT ENABLE_SERVER)
  ecbuild_warn("ENABLE_SERVER is disabled, therefore HTTP_SERVER will also be disabled")
  set(ENABLE_HTTP OFF)
endif()

if(ENABLE_UDP AND NOT ENABLE_SERVER)
  ecbuild_warn("ENABLE_SERVER is disabled, therefore UDP_SERVER will also be disabled")
  set(ENABLE_UDP OFF)
endif()


ecbuild_info( "ENABLE_SERVER              : ${ENABLE_SERVER}" )
ecbuild_info( "ENABLE_PYTHON              : ${ENABLE_PYTHON}" )
ecbuild_info( "ENABLE_PYTHON_PTR_REGISTER : ${ENABLE_PYTHON_PTR_REGISTER}" )
ecbuild_info( "ENABLE_PYTHON_UNDEF_LOOKUP : ${ENABLE_PYTHON_UNDEF_LOOKUP}" )
ecbuild_info( "ENABLE_UI                  : ${ENABLE_UI}" )
ecbuild_info( "ENABLE_TESTS               : ${ENABLE_TESTS} *if* disabled no need for boost test libs" )
ecbuild_info( "ENABLE_ALL_TESTS           : ${ENABLE_ALL_TESTS}" )
ecbuild_info( "ENABLE_STATIC_BOOST_LIBS   : ${ENABLE_STATIC_BOOST_LIBS}" )
ecbuild_info( "ENABLE_SSL                 : ${ENABLE_SSL} *if* openssl libraries available" )
ecbuild_info( "ENABLE_HTTP                : ${ENABLE_HTTP}" )
ecbuild_info( "ENABLE_HTTP_COMPRESSION    : ${ENABLE_HTTP_COMPRESSION}" )
ecbuild_info( "ENABLE_UDP                 : ${ENABLE_UDP}" )


if (ENABLE_UI)
  ecbuild_info( "ENABLE_UI_BACKTRACE        : ${ENABLE_UI_BACKTRACE}" )
  if (UI_BACKTRACE_EMAIL_ADDRESS_FILE)
    ecbuild_info( "UI_BACKTRACE_EMAIL_ADDRESS_FILE : ${UI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
  endif()

  if(LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE)
    ecbuild_info( "LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE : ${LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
  endif()

  if(UI_SYSTEM_SERVERS_LIST)
    ecbuild_info( "UI_SYSTEM_SERVERS_LIST : ${UI_SYSTEM_SERVERS_LIST}" )
  endif()

  ecbuild_info( "ENABLE_UI_USAGE_LOG        : ${ENABLE_UI_USAGE_LOG}" )
  if(ENABLE_UI_USAGE_LOG)
    ecbuild_info( "UI_LOG_FILE                : ${UI_LOG_FILE}" )
    ecbuild_info( "LOGUI_LOG_FILE             : ${LOGUI_LOG_FILE}" )
    ecbuild_info( "UI_LOG_SITE_TAG            : ${UI_LOG_SITE_TAG}" )
  endif()
endif()
ecbuild_info("")


# =========================================================================================
# Setup Project-wide dependencies
# =========================================================================================
include(Dependencies)

# =========================================================================================
# Dependency: Boost
# =========================================================================================
message( STATUS "====================================================================================================================" )
message( STATUS "BOOST" )
# this can help in some situations:
set (_CMAKE_PREFIX_PATH_BACKUP ${CMAKE_PREFIX_PATH}) # make a backup of CMAKE_PREFIX_PATH
foreach(BOOST_PATH_TO_SEARCH ${BOOST_PATH} ${BOOST_ROOT} $ENV{BOOST_ROOT})
    ecbuild_debug("adding: ${BOOST_PATH_TO_SEARCH} to CMAKE_PREFIX_PATH")
    list(APPEND CMAKE_PREFIX_PATH ${BOOST_PATH_TO_SEARCH})
    list(REMOVE_DUPLICATES CMAKE_PREFIX_PATH)
endforeach()

# Ecflow test require statics libs for boost < 1.59, otherwise get double free error.
# To use static boost python ensure that Boost_USE_STATIC_LIBS is set on.
# See: http://www.cmake.org/cmake/help/v3.0/module/FindBoost.html
if ( ENABLE_STATIC_BOOST_LIBS )
    set(Boost_USE_STATIC_LIBS ON)
    ecbuild_info( "Using STATIC boost libraries : ${BOOST_TEST_DYN_LINK}" )
else()
    set(BOOST_TEST_DYN_LINK "BOOST_TEST_DYN_LINK")
    ecbuild_info( "Using SHARED boost libraries setting : ${BOOST_TEST_DYN_LINK}" )
endif()

# By default cmake assume boost was built with cmake. Hence looks for package config file BoostConfig.cmake/boost-config.cmake
# This seems to mess up the search for boost python libs.
# if Boost_NO_BOOST_CMAKE is not set, we seem to mess up in finding right python libs(python3 and python2),

=== ACore/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

configure_file(
  src/ecflow/core/ecflow_version.h.in
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_version.h)
configure_file(
  src/ecflow/core/ecflow_source_build_dir.h.in
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_source_build_dir.h)

set(srcs
  # Headers
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_version.h
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_source_build_dir.h
  src/ecflow/core/AssertTimer.hpp
  src/ecflow/core/Cal.hpp
  src/ecflow/core/Calendar.hpp
  src/ecflow/core/CalendarUpdateParams.hpp
  src/ecflow/core/CheckPt.hpp
  src/ecflow/core/Child.hpp
  src/ecflow/core/Chrono.hpp
  src/ecflow/core/CommandLine.hpp
  src/ecflow/core/DState.hpp
  src/ecflow/core/DebugPerf.hpp
  src/ecflow/core/DurationTimer.hpp
  src/ecflow/core/Ecf.hpp
  src/ecflow/core/EcfPortLock.hpp
  src/ecflow/core/Extract.hpp
  src/ecflow/core/File.hpp
  src/ecflow/core/File_r.hpp
  src/ecflow/core/Filesystem.hpp
  src/ecflow/core/Host.hpp
  src/ecflow/core/Indentor.hpp
  src/ecflow/core/Log.hpp
  src/ecflow/core/LogVerification.hpp
  src/ecflow/core/NOrder.hpp
  src/ecflow/core/NState.hpp
  src/ecflow/core/NodePath.hpp
  src/ecflow/core/Overload.hpp
  src/ecflow/core/Passwd.hpp
  src/ecflow/core/PasswdFile.hpp
  src/ecflow/core/PasswordEncryption.hpp
  src/ecflow/core/Pid.hpp
  src/ecflow/core/PrintStyle.hpp
  src/ecflow/core/SState.hpp
  src/ecflow/core/Serialization.hpp
  src/ecflow/core/Stl.hpp
  src/ecflow/core/Str.hpp
  src/ecflow/core/StringSplitter.hpp
  src/ecflow/core/TimeSeries.hpp
  src/ecflow/core/TimeSlot.hpp
  src/ecflow/core/TimeStamp.hpp
  src/ecflow/core/User.hpp
  src/ecflow/core/Version.hpp
  src/ecflow/core/WhiteListFile.hpp
  src/ecflow/core/cereal_boost_time.hpp
  src/ecflow/core/cereal_optional_nvp.hpp
  src/ecflow/core/perf_timer.hpp
  # Sources
  src/ecflow/core/AssertTimer.cpp
  src/ecflow/core/Cal.cpp
  src/ecflow/core/Calendar.cpp
  src/ecflow/core/Child.cpp
  src/ecflow/core/Chrono.cpp
  src/ecflow/core/CommandLine.cpp
  src/ecflow/core/DState.cpp
  src/ecflow/core/DurationTimer.cpp
  src/ecflow/core/Ecf.cpp
  src/ecflow/core/Extract.cpp
  src/ecflow/core/File.cpp
  src/ecflow/core/File_r.cpp
  src/ecflow/core/Filesystem.cpp
  src/ecflow/core/Host.cpp
  src/ecflow/core/Indentor.cpp
  src/ecflow/core/Log.cpp
  src/ecflow/core/LogVerification.cpp
  src/ecflow/core/NOrder.cpp
  src/ecflow/core/NState.cpp
  src/ecflow/core/NodePath.cpp
  src/ecflow/core/Passwd.cpp
  src/ecflow/core/PasswdFile.cpp
  src/ecflow/core/Pid.cpp
  src/ecflow/core/PrintStyle.cpp
  src/ecflow/core/SState.cpp
  src/ecflow/core/Str.cpp
  src/ecflow/core/StringSplitter.cpp
  src/ecflow/core/TimeSeries.cpp
  src/ecflow/core/TimeSlot.cpp
  src/ecflow/core/TimeStamp.cpp
  src/ecflow/core/User.cpp
  src/ecflow/core/Version.cpp
  src/ecflow/core/WhiteListFile.cpp
)

ecbuild_add_library(
  TARGET
    core
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
    ${CMAKE_BINARY_DIR}/generated/src
  PUBLIC_LIBS
    cereal::cereal # this needs to be public as it appears in public header files used downstream
    $<$<VERSION_LESS:${Boost_VERSION},1.69.0>:Boost::system>
    Boost::filesystem
    Boost::date_time
    Boost::program_options
    $<$<NOT:$<BOOL:${APPLE}>>:crypt>
  DEFINITIONS
    CMAKE
)
target_clangformat(core)

##
## Notice: test_support is an INTERFACE-only test utility library.
##

ecbuild_add_library(
  TARGET
    test_support
  NOINSTALL
  TYPE INTERFACE
  SOURCES
    test/TestSerialisation.hpp
  PUBLIC_INCLUDES
    test
)
target_clangformat(test_support)

set(test_srcs
  # Headers
  test/TestVersioning.hpp
  # Sources
  test/TestCalendar.cpp
  test/TestCereal.cpp
  test/TestCerealOptionalNVP.cpp
  test/TestCerealWithHierarchy.cpp
  test/TestChrono.cpp
  test/TestClassDataMemberInit.cpp
  test/TestCommandLine.cpp
  test/TestCore_main.cpp # contains main() function for test driver
  test/TestExtract.cpp
  test/TestFile.cpp
  test/TestGetUserDetails.cpp
  test/TestLog.cpp
  test/TestMigration.cpp
  test/TestNodePath.cpp
  test/TestPasswdFile.cpp
  test/TestPasswordEncryption.cpp
  test/TestPerfTimer.cpp
  test/TestRealCalendar.cpp
  test/TestSanitizerAS.cpp
  test/TestSanitizerUB.cpp
  test/TestSerialisation.cpp
  test/TestStr.cpp
  test/TestStringSplitPerf.cpp
  test/TestStringSplitter.cpp
  test/TestTimeSeries.cpp
  test/TestTimeSlot.cpp
  test/TestVersion.cpp
  test/TestVersioning.cpp
  test/TestWhiteListFile.cpp
)

ecbuild_add_test(
  TARGET
    u_core
  LABELS
    unit
    nightly
  SOURCES
    ${test_srcs}
  LIBS
    test_support
    core
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    Boost::timer
)
target_clangformat(u_core
  CONDITION ENABLE_TESTS
)

=== ANattr/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(srcs
  # Headers
  src/ecflow/attribute/AutoArchiveAttr.hpp
  src/ecflow/attribute/AutoCancelAttr.hpp
  src/ecflow/attribute/ClockAttr.hpp
  src/ecflow/attribute/CronAttr.hpp
  src/ecflow/attribute/DateAttr.hpp
  src/ecflow/attribute/DayAttr.hpp
  src/ecflow/attribute/GenericAttr.hpp
  src/ecflow/attribute/LateAttr.hpp
  src/ecflow/attribute/NodeAttr.hpp
  src/ecflow/attribute/QueueAttr.hpp
  src/ecflow/attribute/RepeatAttr.hpp
  src/ecflow/attribute/TimeAttr.hpp
  src/ecflow/attribute/TodayAttr.hpp
  src/ecflow/attribute/Variable.hpp
  src/ecflow/attribute/VerifyAttr.hpp
  src/ecflow/attribute/Zombie.hpp
  src/ecflow/attribute/ZombieAttr.hpp
  # Sources
  src/ecflow/attribute/AutoArchiveAttr.cpp
  src/ecflow/attribute/AutoCancelAttr.cpp
  src/ecflow/attribute/ClockAttr.cpp
  src/ecflow/attribute/CronAttr.cpp
  src/ecflow/attribute/DateAttr.cpp
  src/ecflow/attribute/DayAttr.cpp
  src/ecflow/attribute/GenericAttr.cpp
  src/ecflow/attribute/LateAttr.cpp
  src/ecflow/attribute/NodeAttr.cpp
  src/ecflow/attribute/QueueAttr.cpp
  src/ecflow/attribute/RepeatAttr.cpp
  src/ecflow/attribute/TimeAttr.cpp
  src/ecflow/attribute/TodayAttr.cpp
  src/ecflow/attribute/Variable.cpp
  src/ecflow/attribute/VerifyAttr.cpp
  src/ecflow/attribute/Zombie.cpp
  src/ecflow/attribute/ZombieAttr.cpp
)

ecbuild_add_library(
  TARGET
    attributes
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
  PUBLIC_LIBS
    core
    Boost::date_time
)
target_clangformat(attributes)


set(test_srcs
  # Sources
  test/TestAttributes_main.cpp
  test/TestAttrSerialization.cpp
  test/TestCron.cpp
  test/TestDateAttr.cpp
  test/TestDayAttr.cpp
  test/TestLabel.cpp
  test/TestLateAttr.cpp
  test/TestMigration.cpp
  test/TestRepeat.cpp
  test/TestSizeOf.cpp
  test/TestTimeAttr.cpp
  test/TestTodayAttr.cpp
  test/TestVariable.cpp
  test/TestVariableMap.cpp
  test/TestZombieAttr.cpp
)

ecbuild_add_test(
  TARGET
    u_attributes
  LABELS
    unit
    nightly
  SOURCES
    ${test_srcs}
  LIBS
    test_support
    attributes
  TEST_DEPENDS
    u_core
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
)
target_clangformat(u_attributes
  CONDITION ENABLE_TESTS
)

=== ANode/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(srcs
  # Headers
  src/ecflow/node/AbstractObserver.hpp
  src/ecflow/node/Alias.hpp
  src/ecflow/node/Aspect.hpp
  src/ecflow/node/Attr.hpp
  src/ecflow/node/AutoRestoreAttr.hpp
  src/ecflow/node/ClientSuiteMgr.hpp
  src/ecflow/node/ClientSuites.hpp
  src/ecflow/node/CmdContext.hpp
  src/ecflow/node/Defs.hpp
  src/ecflow/node/DefsDelta.hpp
  src/ecflow/node/DefsTreeVisitor.hpp
  src/ecflow/node/EcfFile.hpp
  src/ecflow/node/ExprAst.hpp
  src/ecflow/node/ExprAstVisitor.hpp
  src/ecflow/node/ExprDuplicate.hpp
  src/ecflow/node/ExprParser.hpp
  src/ecflow/node/Expression.hpp
  src/ecflow/node/Family.hpp
  src/ecflow/node/Flag.hpp
  src/ecflow/node/InLimit.hpp
  src/ecflow/node/InLimitMgr.hpp
  src/ecflow/node/JobCreationCtrl.hpp
  src/ecflow/node/JobProfiler.hpp
  src/ecflow/node/Jobs.hpp
  src/ecflow/node/JobsParam.hpp
  src/ecflow/node/Limit.hpp
  src/ecflow/node/LimitFwd.hpp
  src/ecflow/node/Memento.hpp
  src/ecflow/node/MiscAttrs.hpp
  src/ecflow/node/Node.hpp
  src/ecflow/node/NodeContainer.hpp
  src/ecflow/node/NodeFwd.hpp
  src/ecflow/node/NodeState.hpp
  src/ecflow/node/NodeStats.hpp
  src/ecflow/node/NodeTreeVisitor.hpp
  src/ecflow/node/ResolveExternsVisitor.hpp
  src/ecflow/node/ServerState.hpp
  src/ecflow/node/Signal.hpp
  src/ecflow/node/Submittable.hpp
  src/ecflow/node/Suite.hpp
  src/ecflow/node/SuiteChanged.hpp
  src/ecflow/node/System.hpp
  src/ecflow/node/Task.hpp
  src/ecflow/node/TaskScriptGenerator.hpp
  src/ecflow/node/move_peer.hpp
  src/ecflow/node/parser/AutoArchiveParser.hpp
  src/ecflow/node/parser/AutoCancelParser.hpp
  src/ecflow/node/parser/AutoRestoreParser.hpp
  src/ecflow/node/parser/CalendarParser.hpp
  src/ecflow/node/parser/ClockParser.hpp
  src/ecflow/node/parser/CronParser.hpp
  src/ecflow/node/parser/DateParser.hpp
  src/ecflow/node/parser/DayParser.hpp
  src/ecflow/node/parser/DefsParser.hpp
  src/ecflow/node/parser/DefsStateParser.hpp
  src/ecflow/node/parser/DefsStatusParser.hpp
  src/ecflow/node/parser/DefsStructureParser.hpp
  src/ecflow/node/parser/EventParser.hpp
  src/ecflow/node/parser/ExternParser.hpp
  src/ecflow/node/parser/GenericParser.hpp
  src/ecflow/node/parser/InlimitParser.hpp
  src/ecflow/node/parser/LabelParser.hpp
  src/ecflow/node/parser/LateParser.hpp
  src/ecflow/node/parser/LimitParser.hpp
  src/ecflow/node/parser/MeterParser.hpp
  src/ecflow/node/parser/Parser.hpp
  src/ecflow/node/parser/QueueParser.hpp
  src/ecflow/node/parser/RepeatParser.hpp
  src/ecflow/node/parser/TimeParser.hpp
  src/ecflow/node/parser/TodayParser.hpp
  src/ecflow/node/parser/TriggerParser.hpp
  src/ecflow/node/parser/VariableParser.hpp
  src/ecflow/node/parser/VerifyParser.hpp
  src/ecflow/node/parser/ZombieAttrParser.hpp
  # Sources
  src/ecflow/node/Alias.cpp
  src/ecflow/node/Attr.cpp
  src/ecflow/node/AutoRestoreAttr.cpp
  src/ecflow/node/ClientSuiteMgr.cpp
  src/ecflow/node/ClientSuites.cpp
  src/ecflow/node/CmdContext.cpp
  src/ecflow/node/Defs.cpp
  src/ecflow/node/DefsDelta.cpp
  src/ecflow/node/EcfFile.cpp
  src/ecflow/node/ExprAst.cpp
  src/ecflow/node/ExprAstVisitor.cpp
  src/ecflow/node/ExprDuplicate.cpp
  src/ecflow/node/ExprParser.cpp
  src/ecflow/node/Expression.cpp
  src/ecflow/node/Family.cpp
  src/ecflow/node/Flag.cpp
  src/ecflow/node/InLimit.cpp
  src/ecflow/node/InLimitMgr.cpp
  src/ecflow/node/JobCreationCtrl.cpp
  src/ecflow/node/JobProfiler.cpp
  src/ecflow/node/Jobs.cpp
  src/ecflow/node/JobsParam.cpp
  src/ecflow/node/Limit.cpp
  src/ecflow/node/Memento.cpp
  src/ecflow/node/MiscAttrs.cpp
  src/ecflow/node/Node.cpp
  src/ecflow/node/NodeAdd.cpp
  src/ecflow/node/NodeChange.cpp
  src/ecflow/node/NodeContainer.cpp
  src/ecflow/node/NodeDelete.cpp
  src/ecflow/node/NodeFind.cpp
  src/ecflow/node/NodeMemento.cpp
  src/ecflow/node/NodeStats.cpp
  src/ecflow/node/NodeTime.cpp
  src/ecflow/node/NodeTreeVisitor.cpp
  src/ecflow/node/ResolveExternsVisitor.cpp
  src/ecflow/node/ServerState.cpp
  src/ecflow/node/Signal.cpp
  src/ecflow/node/Submittable.cpp
  src/ecflow/node/Suite.cpp
  src/ecflow/node/SuiteChanged.cpp
  src/ecflow/node/System.cpp
  src/ecflow/node/Task.cpp
  src/ecflow/node/TaskScriptGenerator.cpp
  src/ecflow/node/parser/AutoArchiveParser.cpp
  src/ecflow/node/parser/AutoCancelParser.cpp
  src/ecflow/node/parser/AutoRestoreParser.cpp
  src/ecflow/node/parser/CalendarParser.cpp
  src/ecflow/node/parser/ClockParser.cpp
  src/ecflow/node/parser/CronParser.cpp
  src/ecflow/node/parser/DateParser.cpp
  src/ecflow/node/parser/DayParser.cpp
  src/ecflow/node/parser/DefsParser.cpp
  src/ecflow/node/parser/DefsStateParser.cpp
  src/ecflow/node/parser/DefsStatusParser.cpp
  src/ecflow/node/parser/DefsStructureParser.cpp
  src/ecflow/node/parser/EventParser.cpp
  src/ecflow/node/parser/ExternParser.cpp
  src/ecflow/node/parser/GenericParser.cpp
  src/ecflow/node/parser/InlimitParser.cpp
  src/ecflow/node/parser/LabelParser.cpp
  src/ecflow/node/parser/LateParser.cpp
  src/ecflow/node/parser/LimitParser.cpp
  src/ecflow/node/parser/MeterParser.cpp
  src/ecflow/node/parser/Parser.cpp
  src/ecflow/node/parser/QueueParser.cpp
  src/ecflow/node/parser/RepeatParser.cpp
  src/ecflow/node/parser/TimeParser.cpp
  src/ecflow/node/parser/TodayParser.cpp
  src/ecflow/node/parser/TriggerParser.cpp
  src/ecflow/node/parser/VariableParser.cpp
  src/ecflow/node/parser/VerifyParser.cpp
  src/ecflow/node/parser/ZombieAttrParser.cpp
)

ecbuild_add_library(
  TARGET
    node
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
  PUBLIC_LIBS
    attributes
)
target_clangformat(node)


set(test_srcs
  # Headers
  test/MyDefsFixture.hpp
  # Sources
  test/TestAdd.cpp
  test/TestAlias.cpp
  test/TestAssignmentOperator.cpp
  test/TestChangeMgrSingleton.cpp
  test/TestClientSuiteMgr.cpp
  test/TestCopyConstructor.cpp
  test/TestDefStatus.cpp
  test/TestDefs.cpp
  test/TestEcfFile.cpp
  test/TestEcfFileLocator.cpp
  test/TestEnviromentSubstitution.cpp
  test/TestExprParser.cpp
  test/TestExprRepeatDateArithmetic.cpp
  test/TestExprRepeatDateListArithmetic.cpp
  test/TestFindAbsNodePath.cpp
  test/TestFlag.cpp
  test/TestHistoryParser.cpp
  test/TestInLimit.cpp
  test/TestJobCreator.cpp
  test/TestJobProfiler.cpp
  test/TestLimit.cpp
  test/TestMigration.cpp
  test/TestMissNextTimeSlot.cpp
  test/TestMovePeer.cpp
  test/TestNodeBeginRequeue.cpp
  test/TestNodeState.cpp
  test/TestNode_main.cpp # test entry point
  test/TestOrder.cpp
  test/TestPersistence.cpp
  test/TestPreProcessing.cpp
  test/TestRepeatWithTimeDependencies.cpp
  test/TestReplace.cpp
  test/TestSetState.cpp
  test/TestSpecificIssues.cpp
  test/TestSystem.cpp
  test/TestTaskScriptGenerator.cpp
  test/TestTimeDependencies.cpp
  test/TestVariableGeneration.cpp
  test/TestVariableInheritance.cpp
  test/TestVariableSubstitution.cpp
  test/TestVariableSubstitutionDefs.cpp
  test/TestZombies.cpp
)

ecbuild_add_test(
  TARGET
    u_node
  LABELS
    unit
    nightly
  SOURCES
    ${test_srcs}
  LIBS
    test_support
    node
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
  TEST_DEPENDS
    u_attributes
)
target_clangformat(u_node
  CONDITION ENABLE_TESTS)


set(test_srcs
  # Headers
  test/parser/PersistHelper.hpp
  test/parser/TemporaryFile.hpp
  # Sources
  test/parser/PersistHelper.cpp
  test/parser/TemporaryFile.cpp
  test/parser/TestAutoAddExterns.cpp
  test/parser/TestDefsStructurePersistAndReload.cpp
  test/parser/TestMementoPersistAndReload.cpp
  test/parser/TestMigration.cpp
  test/parser/TestParser.cpp
  test/parser/TestParser_main.cpp # test entry point
  test/parser/TestVariableParsing.cpp
)
ecbuild_add_test(
  TARGET
    u_parser
  LABELS
    unit
    nightly
  SOURCES
    ${test_srcs}
  INCLUDES
    test
    test/parser
  LIBS
    node
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
  TEST_DEPENDS
    u_node
)
target_clangformat(u_parser
  CONDITION ENABLE_TESTS
)

if (ENABLE_ALL_TESTS)
  set(test_srcs
    test/TestSingleExprParse.cpp
    test/TestSingleExprParse_main.cpp # test entry point
  )

  ecbuild_add_test(
    TARGET
      u_node_single
    LABELS
      unit
      nightly
    SOURCES
      ${test_srcs}
    LIBS
      node
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    TEST_DEPENDS
      u_anattr
  )
  target_clangformat(u_node_single
    CONDITION ENABLE_TESTS
  )


  set(test_srcs
    # Headers
    test/parser/PersistHelper.hpp
    test/parser/TemporaryFile.hpp
    # Sources
    test/parser/PersistHelper.cpp
    test/parser/TemporaryFile.cpp
    test/parser/TestParserPerformance_main.cpp # test entry point
    test/parser/TestSingleDefsFile.cpp
  )

  ecbuild_add_test(
    TARGET
      p_parser
    LABELS
      performance
      nightly
    SOURCES
      ${test_srcs}
    LIBS
      node
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
      Boost::timer
  )
  target_clangformat(p_parser
    CONDITION ENABLE_TESTS
  )


  set(test_srcs
    # Headers
    test/parser/PersistHelper.hpp
    test/parser/TemporaryFile.hpp
    # Sources
    test/parser/ParseTimer.cpp
    test/parser/PersistHelper.cpp
    test/parser/TemporaryFile.cpp
  )

  # The following is not technically a test (as it makes no checks),
  # but a tool to measure the time it takes to parse 'mega.def' file
  ecbuild_add_test(
    TARGET
      p_parser_timer
    LABELS
      performance
      nightly
    ARGS
      ${CMAKE_CURRENT_SOURCE_DIR}/test/parser/data/single_defs/mega.def
    SOURCES
      ${test_srcs}
    LIBS
      node
      Boost::boost # Boost header-only libraries must be available
      Boost::timer
  )
  target_clangformat(p_parser_timer
    CONDITION ENABLE_TESTS
  )

  # The following is not technically a test (as it makes no checks),
  # but a tool to parse 'mega.def' file
  set(test_srcs
    test/parser/ParseOnly.cpp
  )
  ecbuild_add_test(
    TARGET
      p_parser_only
    LABELS
      performance
      nightly
    ARGS
      ${CMAKE_CURRENT_SOURCE_DIR}/test/parser/data/single_defs/mega.def
    SOURCES
      ${test_srcs}
    LIBS
      node
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
  )
  target_clangformat(p_parser_only
    CONDITION ENABLE_TESTS
  )

endif()

=== Base/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(srcs
  # Headers
  src/ecflow/base/AbstractClientEnv.hpp
  src/ecflow/base/AbstractServer.hpp
  src/ecflow/base/Client.hpp
  src/ecflow/base/ClientOptionsParser.hpp
  src/ecflow/base/ClientToServerRequest.hpp
  src/ecflow/base/Cmd.hpp
  src/ecflow/base/Connection.hpp
  src/ecflow/base/Gnuplot.hpp
  src/ecflow/base/ServerReply.hpp
  src/ecflow/base/ServerToClientResponse.hpp
  src/ecflow/base/Stats.hpp
  src/ecflow/base/WhyCmd.hpp
  src/ecflow/base/ZombieCtrl.hpp
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/base/Openssl.hpp>
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/base/ssl_connection.hpp>
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/base/SslClient.hpp>
  src/ecflow/base/cts/ClientToServerCmd.hpp
  src/ecflow/base/cts/CtsCmdRegistry.hpp
  src/ecflow/base/cts/EditHistoryMgr.hpp
  src/ecflow/base/cts/task/AbortCmd.hpp
  src/ecflow/base/cts/task/CompleteCmd.hpp
  src/ecflow/base/cts/task/CtsWaitCmd.hpp
  src/ecflow/base/cts/task/EventCmd.hpp
  src/ecflow/base/cts/task/InitCmd.hpp
  src/ecflow/base/cts/task/LabelCmd.hpp
  src/ecflow/base/cts/task/MeterCmd.hpp
  src/ecflow/base/cts/task/QueueCmd.hpp
  src/ecflow/base/cts/task/TaskApi.hpp
  src/ecflow/base/cts/task/TaskCmd.hpp
  src/ecflow/base/cts/user/AlterCmd.hpp
  src/ecflow/base/cts/user/BeginCmd.hpp
  src/ecflow/base/cts/user/CFileCmd.hpp
  src/ecflow/base/cts/user/CheckPtCmd.hpp
  src/ecflow/base/cts/user/ClientHandleCmd.hpp
  src/ecflow/base/cts/user/CSyncCmd.hpp
  src/ecflow/base/cts/user/CtsApi.hpp
  src/ecflow/base/cts/user/CtsCmd.hpp
  src/ecflow/base/cts/user/CtsNodeCmd.hpp
  src/ecflow/base/cts/user/DeleteCmd.hpp
  src/ecflow/base/cts/user/EditScriptCmd.hpp
  src/ecflow/base/cts/user/ForceCmd.hpp
  src/ecflow/base/cts/user/FreeDepCmd.hpp
  src/ecflow/base/cts/user/GroupCTSCmd.hpp
  src/ecflow/base/cts/user/LoadDefsCmd.hpp
  src/ecflow/base/cts/user/LogCmd.hpp
  src/ecflow/base/cts/user/LogMessageCmd.hpp
  src/ecflow/base/cts/user/MoveCmd.hpp
  src/ecflow/base/cts/user/OrderNodeCmd.hpp
  src/ecflow/base/cts/user/PathsCmd.hpp
  src/ecflow/base/cts/user/PlugCmd.hpp
  src/ecflow/base/cts/user/QueryCmd.hpp
  src/ecflow/base/cts/user/ReplaceNodeCmd.hpp
  src/ecflow/base/cts/user/RequeueNodeCmd.hpp
  src/ecflow/base/cts/user/RunNodeCmd.hpp
  src/ecflow/base/cts/user/ServerVersionCmd.hpp
  src/ecflow/base/cts/user/ShowCmd.hpp
  src/ecflow/base/cts/user/UserCmd.hpp
  src/ecflow/base/cts/user/ZombieCmd.hpp
  src/ecflow/base/stc/BlockClientZombieCmd.hpp
  src/ecflow/base/stc/DefsCache.hpp
  src/ecflow/base/stc/DefsCmd.hpp
  src/ecflow/base/stc/ErrorCmd.hpp
  src/ecflow/base/stc/GroupSTCCmd.hpp
  src/ecflow/base/stc/PreAllocatedReply.hpp
  src/ecflow/base/stc/SClientHandleCmd.hpp
  src/ecflow/base/stc/SClientHandleSuitesCmd.hpp
  src/ecflow/base/stc/SNewsCmd.hpp
  src/ecflow/base/stc/SNodeCmd.hpp
  src/ecflow/base/stc/SServerLoadCmd.hpp
  src/ecflow/base/stc/SStatsCmd.hpp
  src/ecflow/base/stc/SStringCmd.hpp
  src/ecflow/base/stc/SStringVecCmd.hpp
  src/ecflow/base/stc/SSuitesCmd.hpp
  src/ecflow/base/stc/SSyncCmd.hpp
  src/ecflow/base/stc/ServerToClientCmd.hpp
  src/ecflow/base/stc/StcCmd.hpp
  src/ecflow/base/stc/ZombieGetCmd.hpp
  # Sources
  src/ecflow/base/Client.cpp
  src/ecflow/base/ClientOptionsParser.cpp
  src/ecflow/base/ClientToServerRequest.cpp
  src/ecflow/base/Connection.cpp
  src/ecflow/base/Gnuplot.cpp
  src/ecflow/base/ServerReply.cpp
  src/ecflow/base/ServerToClientResponse.cpp
  src/ecflow/base/Stats.cpp
  src/ecflow/base/WhyCmd.cpp
  src/ecflow/base/ZombieCtrl.cpp
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/base/Openssl.cpp>
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/base/ssl_connection.cpp>
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/base/SslClient.cpp>
  src/ecflow/base/cts/ClientToServerCmd.cpp
  src/ecflow/base/cts/CtsCmdRegistry.cpp
  src/ecflow/base/cts/EditHistoryMgr.cpp
  src/ecflow/base/cts/task/AbortCmd.cpp
  src/ecflow/base/cts/task/CompleteCmd.cpp
  src/ecflow/base/cts/task/CtsWaitCmd.cpp
  src/ecflow/base/cts/task/EventCmd.cpp
  src/ecflow/base/cts/task/InitCmd.cpp
  src/ecflow/base/cts/task/LabelCmd.cpp
  src/ecflow/base/cts/task/MeterCmd.cpp
  src/ecflow/base/cts/task/QueueCmd.cpp
  src/ecflow/base/cts/task/TaskApi.cpp
  src/ecflow/base/cts/task/TaskCmd.cpp
  src/ecflow/base/cts/user/AlterCmd.cpp
  src/ecflow/base/cts/user/BeginCmd.cpp
  src/ecflow/base/cts/user/CFileCmd.cpp
  src/ecflow/base/cts/user/CSyncCmd.cpp
  src/ecflow/base/cts/user/CheckPtCmd.cpp
  src/ecflow/base/cts/user/ClientHandleCmd.cpp
  src/ecflow/base/cts/user/CtsApi.cpp
  src/ecflow/base/cts/user/CtsCmd.cpp
  src/ecflow/base/cts/user/CtsNodeCmd.cpp
  src/ecflow/base/cts/user/DeleteCmd.cpp
  src/ecflow/base/cts/user/EditScriptCmd.cpp
  src/ecflow/base/cts/user/ForceCmd.cpp
  src/ecflow/base/cts/user/FreeDepCmd.cpp
  src/ecflow/base/cts/user/GroupCTSCmd.cpp
  src/ecflow/base/cts/user/LoadDefsCmd.cpp
  src/ecflow/base/cts/user/LogCmd.cpp
  src/ecflow/base/cts/user/LogMessageCmd.cpp
  src/ecflow/base/cts/user/MoveCmd.cpp
  src/ecflow/base/cts/user/OrderNodeCmd.cpp
  src/ecflow/base/cts/user/PathsCmd.cpp
  src/ecflow/base/cts/user/PlugCmd.cpp
  src/ecflow/base/cts/user/QueryCmd.cpp
  src/ecflow/base/cts/user/ReplaceNodeCmd.cpp
  src/ecflow/base/cts/user/RequeueNodeCmd.cpp
  src/ecflow/base/cts/user/RunNodeCmd.cpp
  src/ecflow/base/cts/user/ServerVersionCmd.cpp
  src/ecflow/base/cts/user/ShowCmd.cpp
  src/ecflow/base/cts/user/UserCmd.cpp
  src/ecflow/base/cts/user/ZombieCmd.cpp
  src/ecflow/base/stc/BlockClientZombieCmd.cpp
  src/ecflow/base/stc/DefsCache.cpp
  src/ecflow/base/stc/DefsCmd.cpp
  src/ecflow/base/stc/ErrorCmd.cpp
  src/ecflow/base/stc/GroupSTCCmd.cpp
  src/ecflow/base/stc/PreAllocatedReply.cpp
  src/ecflow/base/stc/SClientHandleCmd.cpp
  src/ecflow/base/stc/SClientHandleSuitesCmd.cpp
  src/ecflow/base/stc/SNewsCmd.cpp
  src/ecflow/base/stc/SNodeCmd.cpp
  src/ecflow/base/stc/SServerLoadCmd.cpp
  src/ecflow/base/stc/SStatsCmd.cpp
  src/ecflow/base/stc/SStringCmd.cpp
  src/ecflow/base/stc/SStringVecCmd.cpp
  src/ecflow/base/stc/SSuitesCmd.cpp
  src/ecflow/base/stc/SSyncCmd.cpp
  src/ecflow/base/stc/ServerToClientCmd.cpp
  src/ecflow/base/stc/StcCmd.cpp
  src/ecflow/base/stc/ZombieGetCmd.cpp
)

ecbuild_add_library(
  TARGET
    base
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
  PUBLIC_LIBS
    node
    Boost::boost # Boost header-only libraries must be available (namely asio)
)
target_clangformat(base)


set(test_srcs
  # Headers
  test/MockServer.hpp
  test/TestHelper.hpp
  # Sources
  test/TestAlterCmd.cpp
  test/TestArchiveAndRestoreCmd.cpp
  test/TestBase_main.cpp # test entry point
  test/TestClientHandleCmd.cpp
  test/TestCmd.cpp
  test/TestDeleteNodeCmd.cpp
  test/TestForceCmd.cpp
  test/TestFreeDepCmd.cpp
  test/TestInLimitAndLimit.cpp
  test/TestLogCmd.cpp
  test/TestMeterCmd.cpp
  test/TestProgramOptions.cpp
  test/TestQueryCmd.cpp
  test/TestQueueCmd.cpp
  test/TestRequest.cpp
  test/TestRequeueNodeCmd.cpp
  test/TestResolveDependencies.cpp
  test/TestSpecificIssues.cpp
  test/TestSSyncCmd.cpp
  test/TestSSyncCmdOrder.cpp
  test/TestSSyncCmd_CH1.cpp
  test/TestStatsCmd.cpp
)

ecbuild_add_test(
  TARGET
    u_base
  LABELS
    unit nightly
  SOURCES
    ${test_srcs}
  INCLUDES
    ../ANode/test
  LIBS
    base
    Threads::Threads
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
  TEST_DEPENDS
    u_parser
)
target_clangformat(u_base
  CONDITION ENABLE_TESTS
)

# The following is not technically a test (as it makes no checks),
# but a tool to measure the time it takes to generate a job file
if (ENABLE_ALL_TESTS)
  set(test_srcs
    # Sources
    test/TestJobGenPerf.cpp
  )

  ecbuild_add_test(
    TARGET
      p_job_gen
    LABELS
      performance
    SOURCES
      ${test_srcs}
    LIBS
      base
      Threads::Threads
  )
  target_clangformat(p_job_gen
    CONDITION ENABLE_TESTS
  )
endif()

=== CSim/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(srcs
  # Headers
  src/ecflow/simulator/Analyser.hpp
  src/ecflow/simulator/AstAnalyserVisitor.hpp
  src/ecflow/simulator/DefsAnalyserVisitor.hpp
  src/ecflow/simulator/FlatAnalyserVisitor.hpp
  src/ecflow/simulator/Simulator.hpp
  src/ecflow/simulator/SimulatorVisitor.hpp
  # Sources
  src/ecflow/simulator/Analyser.cpp
  src/ecflow/simulator/AstAnalyserVisitor.cpp
  src/ecflow/simulator/DefsAnalyserVisitor.cpp
  src/ecflow/simulator/FlatAnalyserVisitor.cpp
  src/ecflow/simulator/Simulator.cpp
  src/ecflow/simulator/SimulatorVisitor.cpp
)
ecbuild_add_library(
  TARGET
    libsimulator
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
  PUBLIC_LIBS
    node
    attributes
    core
)
target_clangformat(libsimulator)

set(test_srcs
  # Headers
  test/TestUtil.hpp
  # Sources
  test/TestAnalysis.cpp
  test/TestAutoArchive.cpp
  test/TestAutoCancel.cpp
  test/TestAutoCancel.cpp
  test/TestAutoRestore.cpp
  test/TestMeter.cpp
  test/TestRepeat.cpp
  test/TestSimulator.cpp
  test/TestSimulator_main.cpp # test entry point
  test/TestTime.cpp
  test/TestToday.cpp
  test/TestUtil.cpp
)
ecbuild_add_test(
  TARGET
    s_simulator
  LABELS
    integration nightly
  SOURCES
    ${test_srcs}
  LIBS
    libsimulator
    Threads::Threads
  TEST_DEPENDS
    u_base
)
target_clangformat(s_simulator CONDITION ENABLE_TESTS)

if (ENABLE_ALL_TESTS)

  ecbuild_add_test(
    TARGET
      s_simulator_single
    LABELS
      integration nightly
    SOURCES
      test/TestSingleSimulator.cpp
      test/TestSingleSimulator_main.cpp # test entry point
      test/TestUtil.cpp
    LIBS
      libsimulator
      Threads::Threads
    TEST_DEPENDS
      u_base
  )
  target_clangformat(s_simulator_single CONDITION ENABLE_TESTS)

endif()

=== Client/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(srcs
  # Headers
  src/ecflow/client/ClientCmdCache.hpp
  src/ecflow/client/ClientEnvironment.hpp
  src/ecflow/client/ClientInvoker.hpp
  src/ecflow/client/ClientOptions.hpp
  src/ecflow/client/Help.hpp
  src/ecflow/client/Rtt.hpp
  src/ecflow/client/UrlCmd.hpp
  # Sources
  src/ecflow/client/ClientCmdCache.cpp
  src/ecflow/client/Rtt.cpp
  src/ecflow/client/ClientEnvironment.cpp
  src/ecflow/client/ClientInvoker.cpp
  src/ecflow/client/Help.cpp
  src/ecflow/client/Rtt.cpp
  src/ecflow/client/ClientOptions.cpp
  src/ecflow/client/UrlCmd.cpp
)

ecbuild_add_library(
  TARGET
    libclient
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
  PUBLIC_LIBS
    base
    Threads::Threads
)
target_clangformat(libclient)

# ========================================================================
# EXE ecflow_client, if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty

ecbuild_add_executable(
  TARGET
    ecflow_client
  SOURCES
    src/ecflow/client/ClientMain.cpp
  LIBS
    libclient
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
)
target_clangformat(ecflow_client)

# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#          
SET_TARGET_PROPERTIES(ecflow_client
  PROPERTIES
    INSTALL_RPATH ""
)



# use, i.e. don't skip the full RPATH for the build tree
#SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
#SET(CMAKE_INSTALL_RPATH "")

# don't add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
#SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)


# ================================================================================                         
# TEST
set(test_srcs
  # Headers
  test/InvokeServer.hpp
  # Sources
  test/TestClient_main.cpp # test entry point
  test/TestClientEnvironment.cpp
  test/TestClientOptions.cpp
  test/TestClientInterface.cpp
  test/TestJobGenOnly.cpp
  test/TestLifeCycle.cpp
  test/TestInitAddVariables.cpp
  test/TestRtt.cpp
  test/TestUrlCmd.cpp
)

if (ENABLE_SERVER)
  list(APPEND test_srcs
    # Headers
    test/SCPort.hpp
    # Sources
    test/SCPort.cpp
    test/TestClientTimeout.cpp
    test/TestClientHandleCmd.cpp
    test/TestCheckPtDefsCmd.cpp
    test/TestCustomUser.cpp
    test/TestGroupCmd.cpp
    test/TestLoadDefsCmd.cpp
    test/TestLogAndCheckptErrors.cpp
    test/TestPasswdFile.cpp
    test/TestPlugCmd.cpp
    test/TestServer.cpp
    test/TestServerAndLifeCycle.cpp
    test/TestServerLoad.cpp
    test/TestSignalSIGTERM.cpp
    test/TestWhiteListFile.cpp
  )
endif()

ecbuild_add_test(
  TARGET
    s_client
  LABELS
    integration nightly
  SOURCES
    ${test_srcs}
  INCLUDES
    ../Base/test
    ../ANode/test
  LIBS
    libclient
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    Boost::timer
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
  DEPENDS
    ecflow_server # the server is launched to support tests
  TEST_DEPENDS
    u_base
)
target_clangformat(s_client
  CONDITION ENABLE_TESTS
)

if (ENABLE_ALL_TESTS AND ENABLE_SERVER)
  #
  # Simple stand alone test
  #
  ecbuild_add_test(
    TARGET
      p_large_defs
    LABELS
      performance
      manual # requires manual definition of env var ECF_TEST_DEFS_DIR
    SOURCES
      # Headers
      test/SCPort.hpp
      # Sources
      test/SCPort.cpp
      test/TestSinglePerf.cpp
      test/TestSinglePerf_main.cpp # test entry point
    INCLUDES
      ../Base/test
    LIBS
      libclient
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    DEPENDS
      ecflow_server # the server is launched to support tests
    TEST_DEPENDS
      u_base
  )
  target_clangformat(p_large_defs
    CONDITION ENABLE_TESTS
  )

  #
  # test migration
  #
  ecbuild_add_test(
    TARGET
      m_migration
    LABELS
      migration
      manual # requires command line argument: m_test_migration <>
    SOURCES
      # Headers
      test/SCPort.hpp
      # Sources
      test/SCPort.cpp
      test/TestMigration.cpp
      test/TestMigration_main.cpp # test entry point
    INCLUDES
      ../Base/test
    LIBS
      libclient
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    DEPENDS
      ecflow_server # the server is launched to support tests
    TEST_DEPENDS
      u_base
  )
  target_clangformat(m_migration
    CONDITION ENABLE_TESTS
  )

endif()

# ===================================================================
# install
# ===================================================================
install (TARGETS ecflow_client DESTINATION bin)

=== Http/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# cpp-httplib requires at least OpenSSL 1.1.1 for https support
# so if we have OpenSSL enabled and the version is less than this,
# we should disable SSL capabilities from the HTTP server

if (OPENSSL_FOUND)
  if (OPENSSL_VERSION VERSION_LESS 1.1.1)
    ecbuild_warn("HTTP_SERVER requires at least OpenSSL 1.1.1 for https support (have version ${OPENSSL_VERSION}) - disabling https in HTTP server")
    remove_definitions(-DECF_OPENSSL)
    set(DISABLED_SSL_IN_HTTP_SERVER 1)
  endif ()
endif ()

set(srcs
  # Headers
  src/ecflow/http/Api.hpp
  src/ecflow/http/ApiV1.hpp
  src/ecflow/http/ApiV1Impl.hpp
  src/ecflow/http/Base64.hpp
  src/ecflow/http/BasicAuth.hpp
  src/ecflow/http/Client.hpp
  src/ecflow/http/DefsStorage.hpp
  src/ecflow/http/HttpServer.hpp
  src/ecflow/http/HttpServerException.hpp
  src/ecflow/http/JSON.hpp
  src/ecflow/http/Options.hpp
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/http/TokenStorage.hpp>
  src/ecflow/http/TreeGeneration.hpp
  src/ecflow/http/TypeToJson.hpp
  # Sources
  src/ecflow/http/Api.cpp
  src/ecflow/http/ApiV1.cpp
  src/ecflow/http/ApiV1Impl.cpp
  src/ecflow/http/BasicAuth.cpp
  src/ecflow/http/Client.cpp
  src/ecflow/http/DefsStorage.cpp
  src/ecflow/http/HttpServer.cpp
  src/ecflow/http/JSON.cpp
  src/ecflow/http/Options.cpp
  src/ecflow/http/TypeToJson.cpp
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/http/TokenStorage.cpp>
)

ecbuild_add_library(
  TARGET libhttp
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
  PUBLIC_LIBS
    base
    libclient
    nlohmann::json
    httplib::httplib
    $<$<BOOL:${ZLIB_FOUND}>:ZLIB::ZLIB>
  PUBLIC_DEFINITIONS
    $<$<BOOL:${ZLIB_FOUND}>:ECF_HTTP_COMPRESSION>
)
target_clangformat(libhttp)

# ========================================================================
# EXE ecflow_http, if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty

ecbuild_add_executable(
  TARGET ecflow_http
  SOURCES
    src/ecflow/http/HttpMain.cpp
  LIBS
    libhttp
    libclient
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
)
target_clangformat(ecflow_http)

# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#          
SET_TARGET_PROPERTIES(ecflow_http
  PROPERTIES
  INSTALL_RPATH ""
)

# use, i.e. don't skip the full RPATH for the build tree
#SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
#SET(CMAKE_INSTALL_RPATH "")

# don't add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
#SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

if (ENABLE_HTTP AND ENABLE_SERVER)

  if (OPENSSL_FOUND AND NOT DISABLED_SSL_IN_HTTP_SERVER)

    set(test_srcs
      # Headers
      test/Certificate.hpp
      test/InvokeServer.hpp
      test/TokenFile.hpp
      # Sources
      test/TestApiV1.cpp
      test/TestHttp_main.cpp # test entry point
    )

    ecbuild_add_test(
      TARGET
        s_http
      LABELS
        integration nightly
      SOURCES
        ${test_srcs}
      INCLUDES
        ../Base/test
      LIBS
        libhttp
        libclient
        libserver
        Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
        $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
      DEPENDS
        ecflow_server # the server is launched to support tests
        ecflow_http
      TEST_DEPENDS
        u_base
        s_client
    )
    target_clangformat(s_http
      CONDITION ENABLE_TESTS
    )
  else ()
    message(WARNING "SSL not enabled - will not run HTTP server tests")
  endif ()

endif ()

# ===================================================================
# install
# ===================================================================
install(TARGETS ecflow_http DESTINATION bin)

=== Pyext/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

### ecflow python bindings
# NOTES:
# 1/ Building multiple python3 versions not supported, since find_python(..) caches variables, Hack: clear cached variable.
#    https://gitlab.kitware.com/cmake/cmake/issues/19820
#
# 2/
# To see the python link line: Do python-config  --ldflags, i.e
#   > /usr/local/apps/python/2.7.8-01/bin/python-config  --ldflags
#   > -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# However on cct we get:
#   > /usr/local/apps/python/2.7.5-01/bin/python-config --ldflags
#   > -L/usr/local/apps/python/2.7.5-01/lib/python2.7/config -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# cct is correct as it has the "-L" but on other machines we rely on /usr/lib/libpython2.7.so.1.0 being there!
# lxop-test does not have /usr/lib/libpython2.7.so.1.0 so ecbuild fails
#
# For problems with the python build, please look in <build-dir>/ecbuild.log, typically non developmental python
# installs may not include python libs or includes
# For ubuntoo to install we need:
#    sudo apt-get install libpython-dev
#

# =============================================================================
# Configure __init__.py to add __version__
# =============================================================================
set(INIT_PY_IN  "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py.in")
set(INIT_PY_OUT "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py")
configure_file(${INIT_PY_IN} ${INIT_PY_OUT} )


# =============================================================================
# Configure setup.py. Note used locally. Uses existing libraries
# =============================================================================
set(SETUP_PY_IN  "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
set(SETUP_PY_OUT "${CMAKE_CURRENT_SOURCE_DIR}/setup.py")
configure_file(${SETUP_PY_IN} ${SETUP_PY_OUT} )

# ==============================================================================
# source files (paths relative to dirs python2/python3)
# ==============================================================================
set(srcs
  # Headers
  ../src/ecflow/python/BoostPythonUtil.hpp
  ../src/ecflow/python/ClientDoc.hpp
  ../src/ecflow/python/DefsDoc.hpp
  ../src/ecflow/python/Edit.hpp
  ../src/ecflow/python/GlossaryDoc.hpp
  ../src/ecflow/python/NodeAttrDoc.hpp
  ../src/ecflow/python/NodeUtil.hpp
  ../src/ecflow/python/Trigger.hpp
  # Sources
  ../src/ecflow/python/BoostPythonUtil.cpp
  ../src/ecflow/python/ClientDoc.cpp
  ../src/ecflow/python/DefsDoc.cpp
  ../src/ecflow/python/EcfExt.cpp
  ../src/ecflow/python/Edit.cpp
  ../src/ecflow/python/ExportClient.cpp
  ../src/ecflow/python/ExportCore.cpp
  ../src/ecflow/python/ExportDefs.cpp
  ../src/ecflow/python/ExportNode.cpp
  ../src/ecflow/python/ExportNodeAttr.cpp
  ../src/ecflow/python/ExportSuiteAndFamily.cpp
  ../src/ecflow/python/ExportTask.cpp
  ../src/ecflow/python/GlossaryDoc.cpp
  ../src/ecflow/python/NodeAttrDoc.cpp
  ../src/ecflow/python/NodeUtil.cpp
  ../src/ecflow/python/Trigger.cpp
)

# =====================================================================
# tests
# =====================================================================
set(u_tests
  py_u_test_add
  py_u_test_collection
  py_u_test_cron
  py_u_test_defs_constructor
  py_u_test_get_attr
  py_u_test_manual
  py_u_test_late
  py_u_test_replace_node
  py_u_test_tutorial
  py_u_TestAddDelete
  py_u_TestAddDeleteFunc
  py_u_TestAddNodeFunc
  py_u_TestAutoAddExtern
  py_u_TestCopy
  py_u_TestDefs
  py_u_TestDefsCheck
  py_u_TestDerivable
  py_u_TestEcf
  py_u_TestError
  py_u_TestFind
  py_u_TestFlag
  py_u_TestGetAllTasks
  py_u_TestJobGeneration
  py_u_TestParent
  py_u_TestRemove
  py_u_TestRepeatArithmetic
  py_u_TestSimulator
  py_u_TestTraversal
  py_u_TestUserManual
  py_u_TestWith
  py_u_sort
)

set(s_tests
  s_TestClientApi
  s_TestPythonChildApi
)


message( STATUS "====================================================================================================================" )
message( STATUS "PYTHON2" )
message( STATUS "====================================================================================================================" )
if(${CMAKE_VERSION} VERSION_LESS "3.12.0") 
  # We only support python2 extension for cmake less 3.12.0
  # cmake 3.12.0 or greater allows multiple boost python libs & hence multiple extensions to be built
  # Using -DPYTHON_EXECUTABLE=/usr/local/apps/python3/3.6.5-01/bin/python3 is not sufficient as the wrong(python2) libs are found
  ecbuild_find_python( VERSION 2.6 REQUIRED )  
  message( STATUS "  PYTHON_FOUND                      : ${PYTHON_FOUND}" )
  message( STATUS "  PYTHONINTERP_FOUND                : ${PYTHONINTERP_FOUND}" )
  message( STATUS "  PYTHONLIBS_FOUND                  : ${PYTHONLIBS_FOUND}" )
  message( STATUS "  PYTHON_VERSION_STRING             : ${PYTHON_VERSION_STRING}" )
  message( STATUS "  PYTHON_VERSION_MAJOR              : ${PYTHON_VERSION_MAJOR}" )
  message( STATUS "  PYTHON_VERSION_MINOR              : ${PYTHON_VERSION_MINOR}" )
  message( STATUS "  PYTHON_VERSION_PATCH              : ${PYTHON_VERSION_PATCH}" )
  message( STATUS "  PYTHON_CONFIG_EXECUTABLE          : ${PYTHON_CONFIG_EXECUTABLE}" )
  message( STATUS "  PYTHON_EXECUTABLE                 : ${PYTHON_EXECUTABLE}" )
  message( STATUS "  PYTHON_INCLUDE_DIRS               : ${PYTHON_INCLUDE_DIRS}" )
  message( STATUS "  PYTHON_LIBRARIES                  : ${PYTHON_LIBRARIES}" )
  if (${PYTHON_VERSION_MAJOR} EQUAL 3)
    ecbuild_error("Need cmake version >= 3.12.0 to build ecflow python3 extension, current cmake version is ${CMAKE_VERSION}")
  endif()

  find_package( Boost ${ECFLOW_BOOST_VERSION} REQUIRED COMPONENTS python )
  add_subdirectory( python2 )
else()
  # ======================================================================================
  # Attempt to build both python2 *AND/OR* python3 ecflow extension, depending on what is found
  # this assumes cmake 3.12.0 min, which added support for boost python2 and python3
  # * NOTICE* that we do *NOT* use REQUIRED when searching for boost python libs
  # ======================================================================================
  find_package(Python2 COMPONENTS Interpreter Development)
  if (Python2_FOUND)
    message( STATUS "  Python2_Interpreter_FOUND         : ${Python2_Interpreter_FOUND}" )
    message( STATUS "  Python2_EXECUTABLE                : ${Python2_EXECUTABLE}" )
    message( STATUS "  Python2_STDLIB                    : ${Python2_STDLIB}    Standard platform independent installation directory" )
    message( STATUS "  Python2_STDARCH                   : ${Python2_STDARCH}   Standard platform dependent installation directory." )
    message( STATUS "  Python2_Development_FOUND         : ${Python2_Development_FOUND}" )
    message( STATUS "  Python2_INCLUDE_DIRS              : ${Python2_INCLUDE_DIRS}" )
    message( STATUS "  Python2_LIBRARIES                 : ${Python2_LIBRARIES}" )
    message( STATUS "  Python2_LIBRARY_DIRS              : ${Python2_LIBRARY_DIRS}" )
    message( STATUS "  Python2_VERSION                   : ${Python2_VERSION}" )
    message( STATUS "  Python2_VERSION_MAJOR             : ${Python2_VERSION_MAJOR}" )
    message( STATUS "  Python2_VERSION_MINOR             : ${Python2_VERSION_MINOR}" )
    message( STATUS "  Python2_VERSION_PATCH             : ${Python2_VERSION_PATCH}" )
    # *****************************************************************************************
    # Although we have found python2 it could be that *ONLY* python3 was module loaded
    # Otherwise will build for python2 and test with python3 interpreter
    # *****************************************************************************************
    if ( Python2_LIBRARIES )
      ecbuild_find_python( VERSION 2.6 REQUIRED ) # if not included iterpreter not found ?
      if ( ${PYTHON_VERSION_MAJOR} EQUAL 2)
        message( STATUS "  PYTHON_FOUND                      : ${PYTHON_FOUND}" )
        message( STATUS "  PYTHONINTERP_FOUND                : ${PYTHONINTERP_FOUND}" )
        message( STATUS "  PYTHONLIBS_FOUND                  : ${PYTHONLIBS_FOUND}" )
        message( STATUS "  PYTHON_VERSION_STRING             : ${PYTHON_VERSION_STRING}" )
        message( STATUS "  PYTHON_VERSION_MAJOR              : ${PYTHON_VERSION_MAJOR}" )
        message( STATUS "  PYTHON_VERSION_MINOR              : ${PYTHON_VERSION_MINOR}" )
        message( STATUS "  PYTHON_VERSION_PATCH              : ${PYTHON_VERSION_PATCH}" )
        message( STATUS "  PYTHON_CONFIG_EXECUTABLE          : ${PYTHON_CONFIG_EXECUTABLE}" )
        message( STATUS "  PYTHON_EXECUTABLE                 : ${PYTHON_EXECUTABLE}" )
        message( STATUS "  PYTHON_INCLUDE_DIRS               : ${PYTHON_INCLUDE_DIRS}" )
        message( STATUS "  PYTHON_LIBRARIES                  : ${PYTHON_LIBRARIES}" )

        if ( Boost_MINOR_VERSION GREATER 66 )
          # cmake 3.15
          # see: https://gitlab.kitware.com/cmake/cmake/issues/19656
          # INTERFACE_LIBRARY targets may only have whitelisted properties."
          set(ECFLOW_BOOST_PYTHON_COMPONENT python${Python2_VERSION_MAJOR}${Python2_VERSION_MINOR})
        else()
          set(ECFLOW_BOOST_PYTHON_COMPONENT python)
        endif()
        find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS ${ECFLOW_BOOST_PYTHON_COMPONENT} )

        if (Boost_PYTHON_FOUND OR Boost_PYTHON${Python2_VERSION_MAJOR}${Python2_VERSION_MINOR}_FOUND)
          # Indicate that both Python and Boost.Python have been found
          set(ECF_PYTHON_FOUND "ECF_PYTHON_FOUND")
          add_subdirectory( python2 )
        else()
          message( STATUS "  Boost python2 libraries *NOT* found" )
        endif()
      endif()
    else()
      message( STATUS "  Python2 libraries *NOT* found" )
    endif()
  endif()

  message( STATUS "====================================================================================================================" )
  message( STATUS "PYTHON3" )
  message( STATUS "====================================================================================================================" )
  # The python must include the Development packages. As the headers in these packages is used by boost python.
  find_package(Python3 COMPONENTS Interpreter Development)
  if (Python3_FOUND)
    message( STATUS "  Python3_Interpreter_FOUND         : ${Python3_Interpreter_FOUND}" )
    message( STATUS "  Python3_EXECUTABLE                : ${Python3_EXECUTABLE}" )
    message( STATUS "  Python3_STDLIB                    : ${Python3_STDLIB}    Standard platform independent installation directory" )
    message( STATUS "  Python3_STDARCH                   : ${Python3_STDARCH}   Standard platform dependent installation directory." )
    message( STATUS "  Python3_Development_FOUND         : ${Python3_Development_FOUND}" )
    message( STATUS "  Python3_INCLUDE_DIRS              : ${Python3_INCLUDE_DIRS}" )
    message( STATUS "  Python3_LIBRARIES                 : ${Python3_LIBRARIES}" )
    message( STATUS "  Python3_LIBRARY_DIRS              : ${Python3_LIBRARY_DIRS}" )
    message( STATUS "  Python3_VERSION                   : ${Python3_VERSION}" )
    message( STATUS "  Python3_VERSION_MAJOR             : ${Python3_VERSION_MAJOR}" )
    message( STATUS "  Python3_VERSION_MINOR             : ${Python3_VERSION_MINOR}" )
    message( STATUS "  Python3_VERSION_PATCH             : ${Python3_VERSION_PATCH}" )

    # Set (deprecated) FindPython variables

=== Server/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(srcs
  # Headers
  src/ecflow/server/BaseServer.hpp
  src/ecflow/server/CheckPtSaver.hpp
  src/ecflow/server/NodeTreeTraverser.hpp
  src/ecflow/server/Server.hpp
  src/ecflow/server/ServerEnvironment.hpp
  src/ecflow/server/ServerOptions.hpp
  src/ecflow/server/SslServer.hpp
  src/ecflow/server/SslTcpServer.hpp
  src/ecflow/server/TcpBaseServer.hpp
  src/ecflow/server/TcpServer.hpp
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/server/SslServer.hpp>
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/server/SslTcpServer.hpp>
  # Sources
  src/ecflow/server/BaseServer.cpp
  src/ecflow/server/CheckPtSaver.cpp
  src/ecflow/server/NodeTreeTraverser.cpp
  src/ecflow/server/Server.cpp
  src/ecflow/server/ServerEnvironment.cpp
  src/ecflow/server/ServerOptions.cpp
  src/ecflow/server/TcpBaseServer.cpp
  src/ecflow/server/TcpServer.cpp
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/server/SslServer.cpp>
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/server/SslTcpServer.cpp>
)

ecbuild_add_library(
  TARGET
    libserver
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
  PUBLIC_LIBS
    base
    Boost::boost # Boost header-only libraries must be available (namely asio)
)
target_clangformat(libserver)

# =======================================================
# EXE ecflow_server, if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty

ecbuild_add_executable(
  TARGET
    ecflow_server
  SOURCES
    src/ecflow/server/ServerMain.cpp
  LIBS
    libserver
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    Threads::Threads
)
target_clangformat(ecflow_server)

# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#          
SET_TARGET_PROPERTIES(ecflow_server
  PROPERTIES
    INSTALL_RPATH ""
)

# use, i.e. don't skip the full RPATH for the build tree
#SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
#SET(CMAKE_INSTALL_RPATH "")

# don't add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
#SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

                          
# ================================================================================                         
# TEST
ecbuild_add_test(
  TARGET
    u_server
  LABELS
    unit nightly
  INCLUDES
    src
  SOURCES
    test/TestCheckPtSaver.cpp
    test/TestServerEnvironment.cpp
    test/TestServer_main.cpp # test entry point
    test/TestServer.cpp
  LIBS
    libserver
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    Threads::Threads
  TEST_DEPENDS
    u_base
)

target_clangformat(u_server CONDITION ENABLE_TESTS)

# ===================================================================
# install
# ===================================================================
install (TARGETS ecflow_server DESTINATION bin)

=== Test/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(srcs
  # Headers
  src/ServerTestHarness.hpp
  src/TestFixture.hpp
  src/ZombieUtil.hpp
  # Sources
  src/ServerTestHarness.cpp
  src/TestFixture.cpp
  src/ZombieUtill.cpp
)

ecbuild_add_library(
  TARGET
    libharness
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
    ../Base/test
  PUBLIC_LIBS
    libclient
    base
    node
    attributes
    core
)
target_clangformat(libharness)

# =================================================================
# test

if (ENABLE_ALL_TESTS)

  set(test_srcs
    Test_main.cpp # test entry point
    TestAbortCmd.cpp
    TestAlias.cpp
    TestClkSync.cpp
    TestComplete.cpp
    TestCron.cpp
    TestCtsWaitCmd.cpp
    TestDayDate.cpp
    TestEcfNoScriptCmd.cpp
    TestEcfScriptCmd.cpp
    TestEvents.cpp
    TestFileCmd.cpp
    TestHandle.cpp
    TestInitAddVariable.cpp
    TestKillCmd.cpp
    TestLate.cpp
    TestLimit.cpp
    TestOrderCmd.cpp
    TestQueueCmd.cpp
    TestRepeat.cpp
    TestRequeueNode.cpp
    TestServer.cpp
    TestSpecificIssues.cpp
    TestSuspend.cpp
    TestTime.cpp
    TestToday.cpp
    TestTrigger.cpp
    TestWhyCmd.cpp
  )

  ecbuild_add_test(
    TARGET
      s_test
    LABELS
      integration
      nightly
    SOURCES
      ${test_srcs}
    LIBS
      libharness
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    TEST_DEPENDS
      s_client
  )
  target_clangformat(s_test CONDITION ENABLE_TESTS)

  ecbuild_add_test(
    TARGET
      s_zombies
    LABELS
      integration
      nightly
    SOURCES
      TestZombies.cpp
      TestZombies_main.cpp # test entry point
    LIBS
      libharness
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    TEST_DEPENDS
      s_test
  )
  target_clangformat(s_zombies CONDITION ENABLE_TESTS)

  # This test runs forever, hence not suitable as unit test.
  ecbuild_add_test(
    TARGET
      s_single
    LABELS
      integration
      manual
    SOURCES
      TestSingle.cpp
      TestSingle_main.cpp # test entry point
    LIBS
      libharness
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    TEST_DEPENDS
      s_client
  )
  target_clangformat(s_single CONDITION ENABLE_TESTS)

endif()

=== Udp/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# ==============================================================================
# ECFLOW UDP library

set(LIB_TARGET libecflow_udp)

set(${LIB_TARGET}_srcs
  # Headers
  src/ecflow/udp/ClientAPI.hpp
  src/ecflow/udp/RequestHandler.hpp
  src/ecflow/udp/Trace.hpp
  src/ecflow/udp/UDPServer.hpp
  src/ecflow/udp/UDPServerEnvironment.hpp
  src/ecflow/udp/UDPServerOptions.hpp
  # Sources
  src/ecflow/udp/ClientAPI.cpp
  src/ecflow/udp/RequestHandler.cpp
  src/ecflow/udp/Trace.cpp
  src/ecflow/udp/UDPServerEnvironment.cpp
  src/ecflow/udp/UDPServerOptions.cpp
)

ecbuild_add_library(
  TARGET
    ${LIB_TARGET}
  TYPE STATIC
  NOINSTALL
  SOURCES
    ${${LIB_TARGET}_srcs}
  PRIVATE_INCLUDES
    src
  PUBLIC_LIBS
    libclient
    nlohmann::json
    Boost::boost
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    Threads::Threads
)
target_clangformat(${LIB_TARGET})

# ==============================================================================
# ECFLOW UDP server

set(SERVER_TARGET ecflow_udp)

set(${SERVER_TARGET}_srcs
  # Sources
  src/ecflow/udp/UDPServerMain.cpp
)

ecbuild_add_executable(
  TARGET ${SERVER_TARGET}
  SOURCES ${${SERVER_TARGET}_srcs}
  INCLUDES
    src
  LIBS
    ${LIB_TARGET}
    core
)
set_target_properties(${SERVER_TARGET} PROPERTIES
  INSTALL_RPATH ""
)
target_clangformat(${SERVER_TARGET})


# ==============================================================================
# ECFLOW UDP Client

set(CLIENT_TARGET ecflow_udp_client)

set(${CLIENT_TARGET}_srcs
  # HEADERS
  src/ecflow/udp/UDPClient.hpp
  # SOURCES
  src/ecflow/udp/UDPClientMain.cpp
)

ecbuild_add_executable(
  TARGET ${CLIENT_TARGET}
  SOURCES ${${CLIENT_TARGET}_srcs}
  INCLUDES
    src
  LIBS
    pthread
    Boost::boost
    Boost::filesystem
)
set_target_properties(${CLIENT_TARGET} PROPERTIES
  INSTALL_RPATH ""
)

target_clangformat(${CLIENT_TARGET})

# ==============================================================================
# ECFLOW UDP Test(s)

set(TEST_TARGET s_udp)

list(APPEND ${TEST_TARGET}_srcs
  # HEADERS
  test/TestSupport.hpp
  # SOURCES
  test/TestUDP_main.cpp
  test/TestUDPServer.cpp
)

ecbuild_add_test(
  TARGET
    ${TEST_TARGET}
  LABELS
    integration nightly
  SOURCES
    ${${TEST_TARGET}_srcs}
  LIBS
    ${LIB_TARGET}
    libclient
    Boost::boost
    Boost::unit_test_framework
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
  DEPENDS
    ecflow_server # the server is launched to support tests
    ${SERVER_TARGET}
  DEFINITIONS
    ${BOOST_TEST_DYN_LINK}
  INCLUDES
    src
  WORKING_DIRECTORY
    ${CMAKE_CURRENT_BINARY_DIR}/test_sandbox
  ENVIRONMENT
    "PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}"
)

target_clangformat(${TEST_TARGET} CONDITION ENABLE_TESTS)

file(COPY test/data/reference.def DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/test_sandbox/data)

=== debian/changelog ===
ecflow (5.12.0-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:45:16 +1100

ecflow (5.12.0-1build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:47:33 +0000

ecflow (5.12.0-1build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:09:14 +0100

ecflow (5.12.0-1) unstable; urgency=medium

  * New upstream release
  * optional.patch: merged upstream
  * g++-13.patch: merged upstream

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 13 Feb 2024 11:15:12 +0000

=== debian/control ===
Source: ecflow
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-buildinfo,
  dh-sequence-python3, 
  python3-all-dev,
  ecbuild (>= 3.3.0-3),
  doxygen,
  chrpath, 
  libmotif-dev, 
  libxpm-dev,
  libssl-dev,
  qt6-base-dev,
  libqt6core5compat6-dev,
  libqt6svg6-dev,
  qt6-charts-dev,
  libqt6opengl6-dev,
  libxkbcommon-dev,
  libboost-test-dev, 
  libboost-serialization-dev,
  libboost-date-time-dev, 
  libboost-timer-dev,
  libboost-chrono-dev,
  libboost-thread-dev,
  libboost-regex-dev, 
  libboost-python-dev (>= 1.71.0-7+b1), 
  libboost-program-options-dev, libboost-filesystem-dev
Standards-Version: 4.6.2
Homepage: https://software.ecmwf.int/wiki/display/ECFLOW/The+ECFLOW+Pre-processor
Vcs-Browser: https://salsa.debian.org/science-team/ecflow.git
Vcs-Git: https://salsa.debian.org/science-team/ecflow.git -b debian/latest


Package: ecflow-server
Architecture: any
Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}, ksh | mksh | pdksh | zsh
Description: Meteorological workflow controller - server 
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.


Package: ecflow-client
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends}, libqt6svg6, ${python3:Depends}, python3-fuse
Description: Client tools for Meteorological workflow
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.
 .
 This package contains the client tools

Package: python3-ecflow
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-fuse
Description: Python3 libraries for ecFlow workflow tools
 ecFlow is a meteorological work flow package that enables
 users to run a large number of programs ( with dependencies
 on each other and on time) in a controlled environment.
 .
 This package contains Python3 modules used in writing ecflow scripts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@  --with-buildsystem=ecbuild


DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_CPU)

# Needed by dh_python
export DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)

PY3VERSIONS:=$(shell py3versions -r)

FPIC_ARCH:= hppa x32 i386 armel armhf
FPIC:=  $(if $(filter $(DEB_TARGET_ARCH), $(FPIC_ARCH)),  -fPIC,  )

CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(FPIC) $(CPPFLAGS)  -DNO_REGEXP
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) $(FPIC)
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) $(FPIC) # -std=c++11

CMAKE_COMMON_FLAGS = \
		-DBOOST_INCLUDEDIR=/usr/include \
		-DBoost_DATE_TIME_LIBRARY_RELEASE=$(LIBDIR)/libboost_date_time.so  \
		-DBoost_TIMER_LIBRARY_RELEASE=$(LIBDIR)/libboost_timer.so \
		-DBoost_CHRONO_LIBRARY_RELEASE=$(LIBDIR)/libboost_chrono.so \
		-DBoost_UNIT_TEST_FRAMEWORK_LIBRARY_RELEASE=$(LIBDIR)/libboost_unit_test_framework.so \
		-DBoost_FILESYSTEM_LIBRARY_RELEASE=$(LIBDIR)/libboost_filesystem.so  \
		-DBoost_PROGRAM_OPTIONS_LIBRARY_RELEASE=$(LIBDIR)/libboost_program_options.so  \
		-DBoost_REGEX_LIBRARY_RELEASE=$(LIBDIR)/libboost_regex.so  \
		-DBoost_SERIALIZATION_LIBRARY_RELEASE=$(LIBDIR)/libboost_serialization.so  \
		-DBoost_SYSTEM_LIBRARY_RELEASE=$(LIBDIR)/libboost_system.so \
		-DBoost_THREAD_LIBRARY_RELEASE=$(LIBDIR)/libboost_thread.so  \
		-DBOOSTROOT=$(LIBDIR)	\
		-DENABLE_STATIC_BOOST_LIBS=OFF \
		-DENABLE_SSL=ON \
		-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}"  

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/build-* share/ecbuild
	rm -f Doc/online/conf.py Pyext/setup.py
	find . -name '*.pyc' -delete
	find . -name '*.job*' -delete

# For the moment set ENABLE_SSL=OFF. Enabling it fails tests

override_dh_auto_configure:
	ln -s /usr/share/ecbuild share/ecbuild
	for p in ${PY3VERSIONS} ; do \
		set -e; \
		PY3AB=`echo $$p | sed -e 's/python3\./python3/' `  ; \
		PY3VER=`echo $$p | sed -e 's/python//' `; \
		PY3UPPER=`echo $${PY3AB} | tr '[:lower:]' '[:upper:]' `  ; \
		dh_auto_configure --builddirectory=debian/build-$$p -- \
			${CMAKE_COMMON_FLAGS} \
			-DPython3_EXECUTABLE=/usr/bin/$$p \
			-DBoost_$${PY3UPPER}_LIBRARY_RELEASE=$(LIBDIR)/libboost_$${PY3AB}.so  ; \
		done

override_dh_auto_build:
	for p in ${PY3VERSIONS} ; do \
		set -e; \
		dh_auto_build  --builddirectory=debian/build-$$p ; done

override_dh_auto_install:
	for p in ${PY3VERSIONS} ; do \
		set -e; \
		dh_auto_install --builddirectory=debian/build-$$p ; \
		done
	#	Drop the suffixes on scripts ...
	mv $(DESTDIR)/usr/bin/ecflow_logserver.sh $(DESTDIR)/usr/bin/ecflow_logserver
	mv $(DESTDIR)/usr/bin/ecflow_start.sh 	$(DESTDIR)/usr/bin/ecflow_start
	mv $(DESTDIR)/usr/bin/ecflow_stop.sh 	$(DESTDIR)/usr/bin/ecflow_stop
	mv $(DESTDIR)/usr/bin/ecflow_fuse.py 	$(DESTDIR)/usr/bin/ecflow_fuse
	mv $(DESTDIR)/usr/bin/ecflow_logsvr.pl	$(DESTDIR)/usr/bin/ecflow_logsvr
